﻿; Nach WindowScaleDPI() müssen bei einigen Gadgets noch einige Werte manuell gesetzt werden.
; Beim Splitter die Splitterposition, bevor aus Autoresizer angewendet werden kann.
; Beim ListIcon die Spaltenbreiten
; Bilder müssen selbst in die richtige Größe gebracht werden.
EnableExplicit


Global _ScaleDPI_X_.f = 1.0
Global _ScaleDPI_Y_.f = 1.0

Prototype.i proto_SetProcessDPIAware()
Prototype.i proto_IsProcessDPIAware()

#DefaultDPIX = 96.0 
#DefaultDPIY = 96.0

Macro ScaleDPIx(x)
   (x)*_ScaleDPI_X_
EndMacro
Macro ScaleDPIy(y)
   (y)*_ScaleDPI_Y_  
EndMacro
Macro dpiX(x)
   (x) * _ScaleDPI_X_   
EndMacro
Macro dpiY(y)
   (y) * _ScaleDPI_Y_
EndMacro

CompilerIf #PB_Compiler_OS = #PB_OS_Windows
   Procedure InitScaleDPI() 
      Protected hDC.i
      Protected lpx.i 
      Protected lpy.i
      Protected dll.i
      Protected SetProcessDPIAware.proto_SetProcessDPIAware
      Protected IsProcessDPIAware.proto_IsProcessDPIAware
      
      
      ;CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_Executable 
         dll = OpenLibrary(#PB_Any,"user32.dll")
         If dll
            ; ab Window Vista
            IsProcessDPIAware = GetFunction(dll, "IsProcessDPIAware")
            SetProcessDPIAware = GetFunction(dll, "SetProcessDPIAware")
            
            If IsProcessDPIAware And SetProcessDPIAware
               If IsProcessDPIAware() = 0
                  SetProcessDPIAware()
               EndIf
            EndIf
            CloseLibrary(dll)
         EndIf
      ;CompilerEndIf
      
      ; Skalierungsfaktor bestimmen
      hDC = GetDC_(#Null)
      If hDC
         lpx = GetDeviceCaps_(hDC,#LOGPIXELSX)  ; DPI-Wert x
         lpy = GetDeviceCaps_(hDC,#LOGPIXELSY)  ; DPI-Wert y
         ReleaseDC_(#Null,hDC)
      EndIf
      
      If lpx > 0
         _ScaleDPI_X_ = lpx / #DefaultDPIX   ; Skalierungsfaktor x
      EndIf
      If lpy > 0
         _ScaleDPI_Y_ = lpy / #DefaultDPIY   ; Skalierungsfaktor y
      EndIf
      
      ; DialogFont
      
      Protected ncm.NONCLIENTMETRICS
      Protected font.i
      Protected name$, points.i, styles.i, charset.i
      
      ncm\cbSize = SizeOf(NONCLIENTMETRICS)
      If SystemParametersInfo_(#SPI_GETNONCLIENTMETRICS,SizeOf(NONCLIENTMETRICS),ncm,#Null)
         name$ = PeekS(@ncm\lfMessageFont\lfFaceName)
         charset = ncm\lfMessageFont\lfCharSet
         
         points = -MulDiv_(ncm\lfMessageFont\lfHeight, 72, lpy)
         
         If ncm\lfMessageFont\lfWeight = 700 : styles|#PB_Font_Bold     : EndIf
         If ncm\lfMessageFont\lfItalic > 0   : styles|#PB_Font_Italic   : EndIf
         
         ; Dialogfont als Standardfont setzen
         font = LoadFont(#PB_Any,name$,points,#PB_Font_HighQuality|styles)
         If font
            SetGadgetFont(#PB_Default,FontID(font))
         EndIf
      EndIf
      
      
   EndProcedure
   Procedure __EnumChild__(hwnd, Parent)
      Protected Buffer.s = Space(256)
      
      GetClassName_(hwnd, @Buffer,256)  
      ;Debug Buffer
      
      If Buffer 
         Protected id = GetProp_(hwnd, "PB_ID")
         ;Debug "ID: " + id
         If IsGadget(id) And GadgetID(id) = hwnd
            ;Debug "isgadget"
            Protected x = GadgetX(id)
            Protected y = GadgetY(id)
            Protected w = GadgetWidth(id)
            Protected h = GadgetHeight(id)
            
            ;Debug "Size: " + x + "," + y + "    " + w + "," + h
            
            ResizeGadget(id, ScaleDPIx(x), ScaleDPIy(y), ScaleDPIx(w), ScaleDPIy(h))
            
         EndIf
         ProcedureReturn #True
      EndIf
      
   EndProcedure
   Procedure WindowScaleDpi(Window)
      ; Skaliert ein Window mit allen Gadgets
      
      If IsWindow(Window)
         Protected x = WindowX(Window)
         Protected y = WindowY(Window)
         Protected w = WindowWidth(Window)
         Protected h = WindowHeight(Window)
         
         ;ResizeWindow(Window, ScaleDPIx(x), ScaleDPIy(y), ScaleDPIx(w), ScaleDPIy(h))
         
         EnumChildWindows_(WindowID(window), @__EnumChild__(), WindowID(window))
         
         ResizeWindow(Window, ScaleDPIx(x), ScaleDPIy(y), ScaleDPIx(w), ScaleDPIy(h))
      EndIf
      
   EndProcedure
   Procedure GadgetScaleDpi(Gadget, LastGadget = 0)
      ; Skaliert ein oder mehrere Gadgets
      Protected i
      
      If LastGadget = 0
         LastGadget = Gadget
      EndIf
      
      For i = Gadget To LastGadget
         If IsGadget(i)
            Protected x = GadgetX(i) 
            Protected y = GadgetY(i) 
            Protected w = GadgetWidth(i) 
            Protected h = GadgetHeight(i) 
            ResizeGadget(i, ScaleDPIx(x), ScaleDPIy(y), ScaleDPIx(w), ScaleDPIy(h))
         EndIf
      Next i
      
   EndProcedure
   
   InitScaleDPI()
CompilerEndIf

; -----------------------------------------------------------
; Alternative Möglichkeit, den Skalierungsfaktor abhängig von der Schrift zu ermitteln 

; Maße der Referenz-Schrift, die beim Entwickeln der GUI verwendet wurde
; Diese sind der Bezugswert für die Skalierung

#Reference_FontWidth    =  7.0  ; MS Sans Serif 8 = 7.21; Tahoma 8 = 7.24; Segue UI 9 = 7.24  
#Reference_FontHeight   = 13.0   ; MS Sans Serif 8 = 13;   Tahoma 8 = 13;   Segoe UI 9 = 15
#Reference_CorrectW     = -1.0   ; Skalierung in der Breite etwas mehr, als sich die Schriftgröße ändert
#Reference_CorrectH     =  6.0   ; Skalierung in der Höhe etwas weniger als sich die Schriftgröße ändert

Procedure.f ScaleFactorX(fontId)
   ; Gibt das Größenverhältnis in der Breite der übergebenen Schriftart gegenüber Segoe UI 9 zurück
   Protected img = CreateImage(#PB_Any, 10, 10)
   Protected Text$ = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890  .,"
   ;Text$ = "0123456789"
   Protected.f h1, w1, fx, fy
   
   If img And StartDrawing(ImageOutput(img))
      DrawingFont(fontId)
      w1 = TextWidth(Text$) * 1 / Len(Text$) + 1
      Debug "Durchschnittsbreite: " + Str(w1)
      fx = (w1 + #Reference_CorrectW)/(#Reference_FontWidth + #Reference_CorrectW)      ; Segoe UI 9 = 7.67, Tahoma 8 = 6.94, MS Sans Serif 8 = 7.21
      
      StopDrawing()
      FreeImage(img)   
   EndIf
   Debug "Scale Factor X: " + StrD(fx)
   ProcedureReturn fx
   
EndProcedure
Procedure.f ScaleFactorY(fontId)
   ; Gibt das Größenverhältnis in der Höhe der übergebenen Schriftart gegenüber Segoe UI 9 zurück
   Protected img = CreateImage(#PB_Any, 10, 10)
   Protected Text$ = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
   
   Protected.f h1, w1, fx, fy
   
   If img And StartDrawing(ImageOutput(img))
      DrawingFont(fontId)
      h1 = TextHeight(Text$)
      ; Debug "Durchschnittshöhe: " + h1
      fy = (h1 + #Reference_CorrectH)/(#Reference_FontHeight + #Reference_CorrectH)     ; Segoe UI 9 = 15, Tahoma 8 = 13, MS Sans Serif 8 = 13
      
      StopDrawing()
      FreeImage(img)   
   EndIf
   Debug "Scale Factor Y: " + StrD(fy)
   ProcedureReturn fy
   
EndProcedure

;                 100%              125%              150%             200               
; Durchschnitt:   Breite x Höhe     Breite x Höhe     Breite x Höhe    Breite x Höhe     
; Tahoma 8         6.952    13       7.98     16       9.92    19       12.5     25      
; MS Sans Serif    7.177    13       8.66     16      10.24    20       13.338   25      
; Segoe UI 9       7.564    15       9.24     20      10.97    25       14.242   32      

   
; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 103
; FirstLine = 28
; Folding = f-
; EnableXP
; Executable = ..\..\1.exe
; CompileSourceDirectory