﻿; Programm zum Bearbeiten und Anzeigen von ChordPro-Dateien
;
; Vereinfachungen beim Editieren:
; 
; Die Funktionstasten F5 bis F9 schreiben Formatanweisungen für die verschiedenen
; Elemente der Chordpro-Datei.
; Der Cursor sitzt dann an der korrekten Stelle, um gleich loszuschreiben.
; 
;   Beispiel: - Cursor an den Textanfang setzen 
;               dann Taste F6 drücken und Titel schreiben.
;             - Cursor vor Wort setzen, worüber das Akkordsymbol kommen soll
;               dann Taste F5 drücken und Symbol schreiben
;
; Wenn ein schon geschriebener Text formatiert werden soll, markiert man ihn und
; drückt dann die Funktionstaste.
; 
;   Beispiel: Titel im Editor markieren, dann F5 Drücken.
;
; Für Akkordsymbole gibt es noch weitere Tastaturkürzel:
;   Mit Alt+A bis Alt+G wird der entsprechende Buchstabe (A bis G) in eckiger Klammer
;   gesetzt, und die Cursorposition sitzt hinter dem Buchstaben, umd den Akkord gleich
;   vervollständigen zu können.
;
; * Transponieren: Ausgangs und Zieltonart angeben - nur die Ansicht wird transponiert.
;   alternativ das Intervall mit Stufe und Vorzeichen angeben, bisher nur aufwärts (3b oder b3)
;     
;   Für die bei der Transponierung benötigten Intervallrechnung habe ich Töne als Intervall
;   von A definiert. Man kann sich Töne wie eine Zeigerposition auf einer Uhr vorstellen
; 
; * Einstellungsdialog umgebaut auf dynDialog
; * Transponieren auf dynDialog umgebaut
; * Combine auf dynDialog eingebaut - bis jetzt nur auf F12 gelegt
; * Scrollen mit Mausrad im Canvas

;PurifierGranularity(1,1,1,1)
EnableExplicit
XIncludeFile "_Include\manifest.pbi"
XIncludeFile "_Include\ScaleDPI.pbi"
XIncludeFile "_Include\DynamicDialogs_suffixed_IDonly.pbi"
XIncludeFile "_Include\ProgrammDataDirecotry.pbi"

Enumeration 
   #Font_Editor
   #Font_Text
   #Font_Chord
   #Font_Title
   #Font_SubTitle
   #Font_Comment
   #Font_Chorus
   #Font_Settings_Title
EndEnumeration

Enumeration 1  ; Directiven
   #Code_Title
   #Code_Subtitle
   #Code_StartOfChorus
   #Code_EndOfChorus
   #Code_Comment
EndEnumeration

Structure s_ton
   ton.w 
   hts.w
EndStructure

Structure s_chords
   chord$
   text$
EndStructure

Structure s_Font
   name$
   size.i
   style.i
   color.i
EndStructure

Structure s_size
   x.i
   y.i
   width.i
   height.i
   state.i
EndStructure

Structure s_savesettings
   fnt_editor.s_Font
   fnt_text.s_Font
   fnt_chord.s_Font
   fnt_title.s_Font
   fnt_subtitle.s_Font
   fnt_comment.s_Font
   fnt_chorus.s_Font
   border_top.i
   border_left.i
   offset_chorus.i
   space_chords.i
   space_lines.i
   space_lines2.i
   space_lines3.i
   
   size_frmMain.s_size
   size_frmSettings.s_size
   size_frmCombine.s_size
   size_frmTranspose.s_size
EndStructure

Structure s_progdata
   config$
   save.s_savesettings   
   canvas_w.d
   canvas_h.d
   defaultFile$
   transpose.l
   trans$
   firstChord$
EndStructure

Global pd.s_progdata

IncludeFile "chordpro_edit3_declare.pbi" ; %DECLAREFILE




;{- Enumerations / DataSections
;{ Windows
Enumeration
   #FormMain
   #FormSettings
   #FormCombine
   #FormTranspose
EndEnumeration
;}
;{ Menu bars
Enumeration
   #Menu_FormMain
EndEnumeration
;}
;{ Menu/Toolbar items
Enumeration
   #Menu_FormMain_New
   #Menu_FormMain_Load
   #Menu_FormMain_Save
   #Menu_FormMain_Print
   #Menu_FormMain_Quit
   #Menu_FormMain_Insert
   #Menu_FormMain_Insert_Chord
   #Menu_FormMain_Insert_Title
   #Menu_FormMain_Insert_Subtitle
   #Menu_FormMain_Insert_Comment
   #Menu_FormMain_Insert_Chorus
   #Menu_FormMain_Fonts
   #Menu_FormMain_Output
   #Menu_FormMain_Transpose
   #ChordKey_A
   #ChordKey_B
   #ChordKey_C
   #ChordKey_D
   #ChordKey_E
   #ChordKey_F
   #ChordKey_G
   #KeyCombine
   #KeyTranspose_Return
   #KeyTranspose_ESC
   #KeyCombine_Return
   #KeyCombine_ESC
EndEnumeration
;}
;{ Status bars
Enumeration
   #StatusBar_FormMain
EndEnumeration
;}
;{ Gadgets
Enumeration
   #FormMain_Editor
   #FormMain_ScrollArea
   #FormMain_Splitter
   #FormMain_Canvas
   
   #FormSettings_Text_Title
   #FormSettings_Text_Subtitle
   #FormSettings_Text_Chords
   #FormSettings_Text_Text
   #FormSettings_Text_Comments
   #FormSettings_Text_Chorus
   #FormSettings_Button_Title
   #FormSettings_Button_Subtitle
   #FormSettings_Button_Chords
   #FormSettings_Button_Text
   #FormSettings_Button_Comments
   #FormSettings_Button_Chorus
   #FormSettings_String_Title
   #FormSettings_String_Subtitle
   #FormSettings_String_Chords
   #FormSettings_String_Text
   #FormSettings_String_Comments
   #FormSettings_String_Chorus
   #FormSettings_Text_Fonts
   #FormSettings_Text_Border
   #FormSettings_Text_Left
   #FormSettings_Text_Top
   #FormSettings_Text_ChorusIndent
   #FormSettings_Spin_Left
   #FormSettings_Spin_Top
   #FormSettings_Spin_Chorus
   #FormSettings_CheckBox_Chorus
   #FormSettings_Text_ChordSpace
   #FormSettings_Spin_ChordSpace
   #FormSettings_Text_LineSpace
   #FormSettings_Spin_LineSpace
   #FormSettings_Text_LineSpace2
   #FormSettings_Spin_LineSpace2
   #FormSettings_Text_LineSpace3
   #FormSettings_Spin_LineSpace3
   #FormSettings_Button_Close
   
   #FormCombine_Text_Info
   #FormCombine_Start
   #FormCombine_Close
   
   #FormTranspose_Text_Info
   #FormTranspose_String_input
   #FormTranspose_Button_Start
   #FormTranspose_Button_Close
EndEnumeration
;}
Define.l Event, EventWindow, EventGadget, EventType, EventMenu
;}
Procedure OpenWindow_FormMain()
   If OpenWindow(#FormMain, 401, 197, 811, 420, "ChordPro Editor", #PB_Window_Invisible|#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_TitleBar|#PB_Window_MaximizeGadget)
      If CreateMenu(#Menu_FormMain, WindowID(#FormMain))
         MenuTitle("Datei")
         MenuItem(#Menu_FormMain_New, "Neu")
         MenuItem(#Menu_FormMain_Load, "Öffnen")
         MenuItem(#Menu_FormMain_Save, "Speichern")
         MenuItem(#Menu_FormMain_Print, "Drucken")
         MenuBar()
         MenuItem(#Menu_FormMain_Quit, "Beenden")
         
         MenuTitle("Einfügen")
         MenuItem(#Menu_FormMain_Insert_Chord, ~"Akkordsymbol\tF 5")
         AddKeyboardShortcut(#FormMain, #PB_Shortcut_F5, #Menu_FormMain_Insert_Chord)
         MenuBar()
         MenuItem(#Menu_FormMain_Insert_Title, ~"Titel\tF 6")
         AddKeyboardShortcut(#FormMain, #PB_Shortcut_F6, #Menu_FormMain_Insert_Title)
         MenuItem(#Menu_FormMain_Insert_Subtitle, ~"Untertitel\tF 7")
         AddKeyboardShortcut(#FormMain, #PB_Shortcut_F7, #Menu_FormMain_Insert_Subtitle)
         MenuItem(#Menu_FormMain_Insert_Comment, ~"Kommentar\tF 8")
         AddKeyboardShortcut(#FormMain, #PB_Shortcut_F8, #Menu_FormMain_Insert_Comment)
         MenuBar()
         MenuItem(#Menu_FormMain_Insert_Chorus, ~"Chorus\tF 9")
         AddKeyboardShortcut(#FormMain, #PB_Shortcut_F9, #Menu_FormMain_Insert_Chorus)
         
        
         MenuTitle("Einstellungen")
         MenuItem(#Menu_FormMain_Fonts, "Editorschrift")
         MenuItem(#Menu_FormMain_Output, "Formatierung")
         MenuItem(#Menu_FormMain_Transpose, "Stück transponieren")
         
      EndIf
      If CreateStatusBar(#StatusBar_FormMain, WindowID(#FormMain))
         AddStatusBarField(#PB_Ignore)
      EndIf
      EditorGadget(#FormMain_Editor, 50, 80, 90, 80, #PB_Editor_WordWrap)
      ScrollAreaGadget(#FormMain_ScrollArea, 230, 70, 70, 95, 1200, 1200, 10, #PB_ScrollArea_Single)
      CanvasGadget(#FormMain_Canvas, 0, 0, 800, 1200)
      CloseGadgetList()
      SplitterGadget(#FormMain_Splitter, 5, 5, 800, 365, #FormMain_Editor, #FormMain_ScrollArea, #PB_Splitter_Separator|#PB_Splitter_Vertical)
      SetGadgetState(#FormMain_Splitter, 400)
   EndIf
EndProcedure
;----------------
Macro SetTransposeIntervall(_Quelle_, _Ziel_)
   TonIntervall(TonVal(_Ziel_), TonVal(_Quelle_), -1)   
EndMacro
Macro TransposeTon(_Ton_, _Intervall_)
   TonStr(TonIntervall(TonVal(_Ton_), _Intervall_, 1))
EndMacro

Procedure.i MaxI(a,b)
   If a > b
      ProcedureReturn a
   Else
      ProcedureReturn b
   EndIf
EndProcedure
Procedure.d MaxD(a.d, b.d)
   If a > b
      ProcedureReturn a
   Else
      ProcedureReturn b
   EndIf
EndProcedure


Procedure Directive(Text$, *text.string = 0)
   Protected x
   Protected code$
   
   If Asc(Text$) = '{'
      
   EndIf
   
EndProcedure

Procedure GetChordParts(Text$, List part.s_chords())
   Protected cnt
   Protected chordInLine
   Protected i
   Protected Teil$
   
   ClearList(part())
   
   cnt = CountString(Text$, "[") + 1
   
   For i = 1 To cnt
      Teil$ = StringField(Text$, i, "[")
      
      If FindString(Teil$, "]")
         AddElement(part())
         
         part()\chord$ = StringField(Teil$, 1, "]")
         part()\text$ = StringField(Teil$, 2, "]")
         If part()\chord$ <> ""
            chordInLine + 1
         EndIf
         
      Else
         If Teil$
            AddElement(part())
            part()\text$ = Teil$
         EndIf
         
      EndIf
   Next i
   
   ProcedureReturn chordInLine
   
EndProcedure
Procedure SplitString(Text$, List Line$())
   Protected *c.character
   Protected *s
   ClearList(Line$())
   
   *c = @Text$
   *s = *c
   
   While *c\c
      If *c\c = #CR
         AddElement(Line$())
         Line$() = PeekS(*s, (*c - *s)/SizeOf(character))
         *s = *c + SizeOf(character) * 2
      EndIf
      *c + SizeOf(character)
   Wend
   
   AddElement(Line$())
   Line$() = PeekS(*s)
   If Line$() = ""
      DeleteElement(Line$())
   EndIf
   
   ProcedureReturn ListSize(Line$())
   
EndProcedure

;---------------






;---------------

Procedure FormMain_Open()
   Protected w, h
   
   OpenWindow_FormMain()
   
   AddKeyboardShortcut(#FormMain, #PB_Shortcut_A|#PB_Shortcut_Alt, #ChordKey_A) 
   AddKeyboardShortcut(#FormMain, #PB_Shortcut_B|#PB_Shortcut_Alt, #ChordKey_B) 
   AddKeyboardShortcut(#FormMain, #PB_Shortcut_C|#PB_Shortcut_Alt, #ChordKey_C) 
   AddKeyboardShortcut(#FormMain, #PB_Shortcut_D|#PB_Shortcut_Alt, #ChordKey_D) 
   AddKeyboardShortcut(#FormMain, #PB_Shortcut_E|#PB_Shortcut_Alt, #ChordKey_E) 
   AddKeyboardShortcut(#FormMain, #PB_Shortcut_F|#PB_Shortcut_Alt, #ChordKey_F) 
   AddKeyboardShortcut(#FormMain, #PB_Shortcut_G|#PB_Shortcut_Alt, #ChordKey_G) 
   AddKeyboardShortcut(#FormMain, #PB_Shortcut_F12, #KeyCombine)
   
   BindEvent(#PB_Event_CloseWindow, @FormMain_Close(), #FormMain)
   BindEvent(#PB_Event_SizeWindow, @FormMain_Resize(), #FormMain)
   BindEvent(#PB_Event_GadgetDrop, @FormMain_Drop(), #FormMain)
   BindEvent(#PB_Event_Menu, @MenuMain_Insert(), #FormMain)
   BindEvent(#PB_Event_Menu, @MenuMain_Combine(), #FormMain, #KeyCombine)
   
   BindGadgetEvent(#FormMain_Splitter, @FormMain_Splitter())
   BindGadgetEvent(#FormMain_Editor, @FormMain_Edit())
   BindGadgetEvent(#FormMain_Canvas, @FormMain_Canvas())
   BindGadgetEvent(#FormMain_ScrollArea, @FormMain_ScrollArea())
   
   BindMenuEvent(#Menu_FormMain, #Menu_FormMain_Print, @PrinterDraw())
   BindMenuEvent(#Menu_FormMain, #Menu_FormMain_Output, @FormSettings_Open())
   BindMenuEvent(#Menu_FormMain, #Menu_FormMain_Fonts, @MenuMain_EditorFont())
   BindMenuEvent(#Menu_FormMain, #Menu_FormMain_Transpose, @MenuMain_Transpose())
   BindMenuEvent(#Menu_FormMain, #Menu_FormMain_Load, @MenuMain_Load())
   BindMenuEvent(#Menu_FormMain, #Menu_FormMain_Save, @MenuMain_Save())
   BindMenuEvent(#Menu_FormMain, #Menu_FormMain_New, @MenuMain_New())
   
   With pd\save\fnt_editor
      Debug \name$
      LoadFont(#Font_Editor, \name$, \size, \style|#PB_Font_HighQuality)
   EndWith
   
   With pd\save\fnt_title
      Debug \name$
      LoadFont(#Font_Title, \name$, \size, \style|#PB_Font_HighQuality)
   EndWith
   With pd\save\fnt_subtitle
      LoadFont(#Font_SubTitle, \name$, \size, \style|#PB_Font_HighQuality)
   EndWith
   With pd\save\fnt_chord
      LoadFont(#Font_Chord, \name$, \size, \style|#PB_Font_HighQuality)
   EndWith
   With pd\save\fnt_text
      LoadFont(#Font_Text, \name$, \size, \style|#PB_Font_HighQuality)
   EndWith
   With pd\save\fnt_chorus
      LoadFont(#Font_Chorus, \name$, \size, \style|#PB_Font_HighQuality)
   EndWith
   With pd\save\fnt_comment
      LoadFont(#Font_Comment, \name$, \size, \style|#PB_Font_HighQuality)
   EndWith
;    LoadFont(#Font_Text, "Arial", 12, #PB_Font_HighQuality)
;    LoadFont(#Font_Chord, "Arial", 10, #PB_Font_Italic|#PB_Font_Bold)
;    LoadFont(#Font_Title, "Arial", 18, #PB_Font_Bold|#PB_Font_HighQuality)
;    LoadFont(#Font_SubTitle, "Arial", 10, #PB_Font_HighQuality)
;    LoadFont(#Font_Chorus, "Arial", 12, #PB_Font_Bold)
;    LoadFont(#Font_Comment, "Arial", 10, #PB_Font_Italic)
   
   w = GadgetWidth(#FormMain_ScrollArea) 
   h = GadgetHeight(#FormMain_ScrollArea)
   Debug w
   Debug h
   SetGadgetColor(#FormMain_ScrollArea, #PB_Gadget_BackColor, $ffffff)
   SetGadgetAttribute(#FormMain_ScrollArea, #PB_ScrollArea_InnerWidth, 100)
   SetGadgetAttribute(#FormMain_ScrollArea, #PB_ScrollArea_InnerHeight, 100)
   ResizeGadget(#FormMain_Canvas, 0, 0, 595, 841)
   EnableGadgetDrop(#FormMain_Editor, #PB_Drop_Files, #PB_Drag_Copy)
   
   pd\canvas_w = 595
   pd\canvas_h = 841
   
   SetGadgetFont(#FormMain_Editor, FontID(#Font_Editor))
   
   With pd\save\size_frmMain
      ResizeWindow(#FormMain, \x, \y, dpiX(\width), dpiY(\height))
      If \state & #PB_Window_Minimize = 0
         SetWindowState(#FormMain, \state)
      EndIf
   EndWith

   FormMain_Resize()
   
EndProcedure
Procedure FormMain_Close()
   With pd\save\size_frmMain
      \state = GetWindowState(#FormMain)
      SetWindowState(#FormMain, #PB_Window_Normal)
      \x = WindowX(#FormMain)
      \y = WindowY(#FormMain)
      \width = WindowWidth(#FormMain)/_ScaleDPI_X_
      \height = WindowHeight(#FormMain)/_ScaleDPI_Y_
   EndWith
   With pd\save\size_frmSettings
      \x = WindowX(#FormSettings)
      \y = WindowY(#FormSettings)
      \width = WindowWidth(#FormSettings)/_ScaleDPI_X_
      \height = WindowHeight(#FormSettings)/_ScaleDPI_Y_
   EndWith
   With pd\save\size_frmCombine
      \x = WindowX(#FormCombine)
      \y = WindowY(#FormCombine)
      \width = WindowWidth(#FormCombine)/_ScaleDPI_X_
      \height = WindowHeight(#FormCombine)/_ScaleDPI_Y_
   EndWith
   With pd\save\size_frmTranspose
      \x = WindowX(#FormTranspose)
      \y = WindowY(#FormTranspose)
      \width = WindowWidth(#FormTranspose)/_ScaleDPI_X_
      \height = WindowHeight(#FormTranspose)/_ScaleDPI_Y_
   EndWith
   
   Debug "SCHLIESSEN"
   SaveSettings(pd\config$)
   End
   
EndProcedure
Procedure FormMain_Resize()
   Protected ww, wh
   ww = WindowWidth(#FormMain)
   wh = WindowHeight(#FormMain)
   
   ResizeGadget(#FormMain_Splitter, dpiX(10), dpiY(10), ww - dpiX(20), wh - dpiY(20) - MenuHeight() - StatusBarHeight(0)) 
EndProcedure
;---
Procedure FormMain_ScrollArea()
   
   Debug "SCROLL"
   
EndProcedure
Procedure FormMain_Canvas()
   Protected weeldata, pos
   
   Select EventType()
      Case #PB_EventType_MouseWheel
         Debug "Weel"
         weeldata = GetGadgetAttribute(#FormMain_Canvas, #PB_Canvas_WheelDelta)
         Debug weeldata
         pos = GetGadgetAttribute(#FormMain_ScrollArea, #PB_ScrollArea_Y)
         SetGadgetAttribute(#FormMain_ScrollArea, #PB_ScrollArea_Y, pos + (weeldata * -50))
   EndSelect
   
EndProcedure
Procedure FormMain_Edit()
   Select EventType()
      Case #PB_EventType_Change
         Debug "CHANGE"
         CanvasDraw()
   EndSelect
   
   
EndProcedure
Procedure FormMain_Splitter()
   Debug "Splitter"
   
EndProcedure
Procedure FormMain_Drop()
   Debug "Drop"   
   Protected File$
   
   If EventGadget() = #FormMain_Editor
      If EventDropType() = #PB_Drop_Files
         File$ = EventDropFiles()
         File$ = StringField(File$, 1, #LF$)
         pd\defaultFile$ = File$
         LoadText(File$)
         CanvasDraw()
      EndIf
   EndIf
   
EndProcedure
;---
Procedure MenuMain_Transpose()
   
   FormTranspose_Open()
   
EndProcedure
Procedure MenuMain_EditorFont()
   Debug "Editor"   
   
   With pd\save\fnt_editor
      If FontRequester(\name$, \size, 0, 0, \style)
         \name$ = SelectedFontName()
         \size = SelectedFontSize()
         \style = SelectedFontStyle()
      EndIf
   EndWith
   
EndProcedure
Procedure MenuMain_New()
   Debug "NEU"   
   SetGadgetText(#FormMain_Editor, " ")
   CanvasDraw()
   ClearGadgetItems(#FormMain_Editor)
   pd\defaultFile$ = ""
   pd\trans$ = ""
   pd\transpose = 0
   pd\firstChord$ = ""
   SetGadgetText(#FormTranspose_String_input, "")
   SetActiveGadget(#FormMain_Editor)
EndProcedure
Procedure MenuMain_Load()
   Protected pattern$, file$
   
   pattern$ = "ChordPro |*.cho;*.pro;*.chopro;chordpro|alles|*.*"
   file$ = OpenFileRequester("Öffne ChordPro-Datei", pd\defaultFile$, pattern$, 0)
   If file$ > ""
      pd\defaultFile$ = file$
      pd\trans$ = ""
      pd\transpose = 0
      pd\firstChord$ = ""
      SetGadgetText(#FormTranspose_String_input, "")
      LoadText(file$)
      CanvasDraw()
   EndIf
      
EndProcedure
Procedure MenuMain_Save()
   Protected pattern$, file$
   Debug "SAVE"
   pattern$ = "ChordPro |*.cho;*.pro;*.chopro;*.chordpro|alles|*.*"
   file$ = SaveFileRequester("Speicher ChordPro-Datei", pd\defaultFile$, pattern$, 0)
   
   If file$ <> ""
      If LCase(GetExtensionPart(file$)) = ""
         file$ + ".chopro"
      EndIf
      SaveText(file$)
      pd\defaultFile$ = file$
   EndIf
   
EndProcedure
Procedure Editor_InsertText(ID, a$, b$)
   Protected a, b, Text$
   
   ; Anfang und Ende der Selektion ermitteln
   SendMessage_(GadgetID(ID), #EM_GETSEL, @a, @b)
   
   ; Cursor ans Ende setzen und b$ einfügen
   SendMessage_(GadgetID(ID), #EM_SETSEL, b, b)
   SendMessage_(GadgetID(ID), #EM_REPLACESEL, 0, b$)
   
   ; Cursor an den Anfang setzen und a$ einfügen
   SendMessage_(GadgetID(ID), #EM_SETSEL, a, a)
   SendMessage_(GadgetID(ID), #EM_REPLACESEL, 0, a$)
   
   ; Gaget wieder Aktiv machen
   SetActiveGadget(ID)
   
EndProcedure
Procedure MenuMain_Insert()
   Select EventMenu()
      Case #Menu_FormMain_Insert_Chord
         Debug "CHORD"
         Editor_InsertText(#FormMain_Editor, "[", "]")
         
      Case #Menu_FormMain_Insert_Title
         Debug "TITLE"
         Editor_InsertText(#FormMain_Editor, "{title:", "}")
         
      Case #Menu_FormMain_Insert_Subtitle
           Debug "SUBTITLE"
         Editor_InsertText(#FormMain_Editor, "{subtitle:", "}")
         
      Case #Menu_FormMain_Insert_Comment
         Debug "COMMENT"
         Editor_InsertText(#FormMain_Editor, "{comment:", "}")
         
      Case #Menu_FormMain_Insert_Chorus
         Debug "CHORUS"
         Editor_InsertText(#FormMain_Editor, "{soc}" + #CRLF$, #CRLF$ + "{eoc}" + #CRLF$ )
         
      Case #ChordKey_A To #ChordKey_G
         
         Editor_InsertText(#FormMain_Editor, "[" + Chr('A' + EventMenu() - #ChordKey_A), "]")
         
   EndSelect
   
EndProcedure
Procedure MenuMain_Combine()
   FormCombine_Open()
EndProcedure

;--------------



Procedure CreateDynamicDialogs()
   Protected Text$
   
   UseModule DynamicDialogs
   UseModule DynamicDialogs_suffixed_IDonly
   
   LoadFont(#Font_Settings_Title, "Tahoma", 9, #PB_Font_Bold|#PB_Font_HighQuality)

   Dialogs__()
     
      Window__(#FormSettings, "Formatierungseinstellungen", #PB_Window_Invisible|#PB_Window_SystemMenu|#PB_Window_SizeGadget)  ;{ Settings
         vBox__(1)
            FontByID__(#Font_Settings_Title)
            Frame__(#PB_Any, "Schriftarten")
               EndFont__()
               GridBox__(3, 0, 5, 2)
                  Text__(#FormSettings_Text_Title, "  Titel: ")
                  String__(#FormSettings_String_Title, FontText(pd\save\fnt_title))
                  Button__(#FormSettings_Button_Title, "...")
                  
                  Text__(#FormSettings_Text_Subtitle, "  Untertitel: ")
                  String__(#FormSettings_String_Subtitle, FontText(pd\save\fnt_subtitle))
                  Button__(#FormSettings_Button_Subtitle, "...")
                  
                  Text__(#FormSettings_Text_Comments, "  Kommentare: ")
                  String__(#FormSettings_String_Comments, FontText(pd\save\fnt_comment))
                  Button__(#FormSettings_Button_Comments, "...")
                  
                  Text__(#FormSettings_Text_Text, "  Liedtext: ")
                  String__(#FormSettings_String_Text, FontText(pd\save\fnt_text))
                  Button__(#FormSettings_Button_Text, "...")
                  
                  Text__(#FormSettings_Text_Chords, "  Akkorde: ")
                  String__(#FormSettings_String_Chords, FontText(pd\save\fnt_chord))
                  Button__(#FormSettings_Button_Chords, "...")
                  
                  Text__(#FormSettings_Text_Chorus, "  Refrain: ")
                  String__(#FormSettings_String_Chorus, FontText(pd\save\fnt_chorus))
                  Button__(#FormSettings_Button_Chorus, "...")
                  
               EndGridBox__()
            EndFrame__()
            FontByID__(#Font_Settings_Title)
            Frame__(#PB_Any, "Abstände")
               EndFont__()
               hBox__(2)
                  GridBox__(2)
                     Text__(#FormSettings_Text_Top, "  Oberer Rand:")
                     Spin__(#FormSettings_Spin_Top, 0, 100, pd\save\border_top, #PB_Spin_Numeric)
                     Text__(#FormSettings_Text_Left, "  Linker Rand:")
                     Spin__(#FormSettings_Spin_Left, 0, 100, pd\save\border_left)
                     Text__(#FormSettings_Text_ChorusIndent, "  Einzug Chorus:")
                     Spin__(#FormSettings_Spin_Chorus, 0, 100, pd\save\offset_chorus)
                     Text__(#FormSettings_Text_ChordSpace, "  min. Akkordsymbol-Abstand: ")
                     Spin__(#FormSettings_Spin_ChordSpace, 0, 100, pd\save\space_chords)
                     Text__(#FormSettings_Text_LineSpace, "  Zeilenabstand Titel/Kommentare: +")
                     Spin__(#FormSettings_Spin_LineSpace, 0, 100, pd\save\space_lines)
                     Text__(#FormSettings_Text_LineSpace2, "  Zeilenabstand Liedtext: +")
                     Spin__(#FormSettings_Spin_LineSpace2, 0, 100, pd\save\space_lines2)
;                      Text__(#FormSettings_Text_LineSpace3, "  Akkordzeile Abst. +")
;                      Spin__(#FormSettings_Spin_LineSpace3, 0, 100, pd\save\space_lines3)
                  EndGridBox__()
               EndHBox__()
            EndFrame__()
            hBox__(1)
               Empty__()
               Button__(#FormSettings_Button_Close, "  Schließen  ")
               Empty__(30)
            EndHBox__()
         EndVBox__()
         
      EndWindow__()       ;}
      
      Window__(#FormCombine, "ChordPro Combine", #PB_Window_Invisible|#PB_Window_SystemMenu|#PB_Window_SizeGadget, 450, 315) ;{ Combine
         vBox__(1)
            Editor__(#FormCombine_Text_Info, "", #PB_Editor_ReadOnly|#PB_Editor_WordWrap)
            hBox__()
               Button__(#FormCombine_Start, "Markierte Zeilen umwandeln")
               Button__(#FormCombine_Close, "Schließen")
            EndHBox__()
         EndVBox__()
         
      EndWindow__() ;}
      
      Window__(#FormTranspose, "Transponieren", #PB_Window_Invisible|#PB_Window_SystemMenu) ;{ Transpose
         vBox__(0, 0, 10)
            Text$ = "Bitte die Ausgangs- und Zieltonart angeben, " + #CRLF$ + 
                    "in Großbuchstaben durch Leerzeichen getrennt:"
            
            Text__(#FormTranspose_Text_Info, Text$)
            Font__("Arial", 12, #PB_Font_Bold)
            String__(#FormTranspose_String_input, "")
            EndFont__()
            hBox__(#Expand_Equal)
               
               Button__(#FormTranspose_Button_Start, "Start")
               Button__(#FormTranspose_Button_Close, "Schließen")
            EndHBox__()
               
         EndVBox__()
         
      EndWindow__() ;}
      
   EndDialogs__()
   
   UnuseModule DynamicDialogs_suffixed_IDonly
   
   
   Protected win
   
   With pd\save\size_frmSettings
      win = OpenDialogWindow(#FormSettings, GetXML(), #FormSettings, "", \x, \y, dpiX(\width), dpiY(\height))
   EndWith
   
   If win   
      
      
      BindEvent(#PB_Event_CloseWindow, @FormSettings_Close())
      BindEvent(#PB_Event_Gadget, @FormSettings_Gadgets(), #FormSettings)
      BindGadgetEvent(#FormSettings_Button_Close, @FormSettings_Close())
      
      With pd\save
         SetGadgetText(#FormSettings_Spin_Left, Str(\border_left))
         SetGadgetText(#FormSettings_Spin_Top, Str(\border_top))
         SetGadgetText(#FormSettings_Spin_Chorus, Str(\offset_chorus))
         SetGadgetText(#FormSettings_Spin_ChordSpace, Str(\space_chords))
         SetGadgetText(#FormSettings_Spin_LineSpace, Str(\space_lines))
         SetGadgetText(#FormSettings_Spin_LineSpace2, Str(\space_lines2))
;         SetGadgetText(#FormSettings_Spin_LineSpace3, Str(\space_lines3))
      EndWith
      
      
      
;       BindEvent(#PB_Event_Gadget, @FormSettings_Gadgets(), #FormSettings)
;       If CreatePopupMenu(#PopupSettings)
;          MenuItem(#PopupSettings_Font, "Schriftart")
;          MenuItem(#PopupSettings_Color, "Schriftfarbe")
;          MenuItem(#PopupSettings_Space, "Zeilenabstand")
;          MenuItem(#PopupSettings_Indent, "Einzug")
;       EndIf
;       
;       BindEvent(#PB_Event_Menu, @Popup_FormSettings(), #FormSettings) 
      
      
   EndIf
   
   With pd\save\size_frmCombine
      win = OpenDialogWindow(#FormCombine, GetXML(), #FormCombine, "", \x, \y, 0, 0, WindowID(#FormMain))
   EndWith
   If win
      BindEvent(#PB_Event_CloseWindow, @FormCombine_Close(), #FormCombine)
      BindGadgetEvent(#FormCombine_Close, @FormCombine_Close())
      BindGadgetEvent(#FormCombine_Start, @FormCombine_Start())
      Text$ = PeekS(?rtf_start, ?rtf_ende - ?rtf_start, #PB_UTF8)
      SetRTFText(#FormCombine_Text_Info, Text$)
      
      AddKeyboardShortcut(#FormCombine, #PB_Shortcut_Return, #KeyCombine_Return)
      AddKeyboardShortcut(#FormCombine, #PB_Shortcut_Escape, #KeyCombine_ESC)
      
      BindEvent(#PB_Event_Menu, @FormCombine_Start(), #FormCombine, #KeyCombine_Return)
      BindEvent(#PB_Event_Menu, @FormCombine_Close(), #FormCombine, #KeyCombine_ESC)
   EndIf
   
   With pd\save\size_frmTranspose
      win = OpenDialogWindow(#FormTranspose, GetXML(), #FormTranspose, "", \x, \y, 0, 0, WindowID(#FormMain))
   EndWith
   If win
      BindEvent(#PB_Event_CloseWindow, @FormTranspose_Close(), #FormTranspose)
      BindGadgetEvent(#FormTranspose_Button_Close, @FormTranspose_Close())
      BindGadgetEvent(#FormTranspose_Button_Start, @FormTranspose_Button_Start())
      
      AddKeyboardShortcut(#FormTranspose, #PB_Shortcut_Return, #KeyTranspose_Return)
      AddKeyboardShortcut(#FormTranspose, #PB_Shortcut_Escape, #KeyTranspose_ESC)
      
      BindEvent(#PB_Event_Menu, @FormTranspose_Close(), #FormTranspose, #KeyTranspose_ESC)
      BindEvent(#PB_Event_Menu, @FormTranspose_Button_Start(), #FormTranspose, #KeyTranspose_Return)
   EndIf
   
   
EndProcedure

;------------------------------
Procedure FormSettings_Open()
   ; Einstellungsfenster anzeigen und hervorholen
   
   HideWindow(#FormSettings, 0)
   SetActiveWindow(#FormSettings)
   
EndProcedure
Procedure FormSettings_Close()
   ; Einstellungsfenster verstecken
   
   HideWindow(#FormSettings, 1)   
   
EndProcedure

Procedure.s StyleName(style)
   ; Gibt den Font-Style als Text zurück
   Protected Text$
   
   If style & #PB_Font_Bold
      Text$ + ", Fett"
   EndIf
   If style & #PB_Font_Italic
      Text$ + ", Kursiv"
   EndIf
   If style & #PB_Font_Underline
      Text$ + ", Unterstrichen"
   EndIf
   If style & #PB_Font_StrikeOut
      Text$ + ", Durchgestrichen"
   EndIf
   
   ProcedureReturn Text$
   
EndProcedure
Procedure.s FontText(*f.s_Font)
   If *f
      ProcedureReturn *f\name$ + " " + *f\size + StyleName(*f\style)
   EndIf
EndProcedure

Macro ButtonFont(_gadget_, _font_, _with_)
   ; Schriftauswahldialog aufrufen und neue Werte speichern   
   
   If FontRequester(_with_\name$, _with_\size, #PB_FontRequester_Effects, _with_\color, _with_\style)
      _with_\name$ = SelectedFontName()
      _with_\size = SelectedFontSize()
      _with_\style = SelectedFontStyle()
      _with_\color = SelectedFontColor()
      LoadFont(_font_, _with_\name$, _with_\size, _with_\style|#PB_Font_HighQuality)
      SetGadgetText(_gadget_, _with_\name$ + ", " + Str(_with_\size) + StyleName(_with_\style))
   EndIf
         
EndMacro
Macro SpinVal(_gadget_, _value_)
   ; Spingadget setzen durch schreiben oder hoch und runter schalten
   
   Select EventType() 
      Case #PB_EventType_Up, #PB_EventType_Down
         _value_ = GetGadgetState(_gadget_)
         SetGadgetText(_gadget_, Str(_value_))
      Case #PB_EventType_Change
         _value_ = Val(GetGadgetText(_gadget_))
         SetGadgetState(_gadget_, _value_)
   EndSelect
   
EndMacro

Procedure FormSettings_Gadgets()
   Debug "GADGET"  
   Protected wert
   
   Select EventGadget()
      Case #FormSettings_Button_Title
         ButtonFont(#FormSettings_String_Title, #Font_Title, pd\save\fnt_title)
         
      Case #FormSettings_Button_Subtitle
         ButtonFont(#FormSettings_String_Subtitle, #Font_SubTitle, pd\save\fnt_subtitle)
         
      Case #FormSettings_Button_Chords
         ButtonFont(#FormSettings_String_Chords, #Font_Chord, pd\save\fnt_chord)
         
      Case #FormSettings_Button_Text
         ButtonFont(#FormSettings_String_Text, #Font_Text, pd\save\fnt_text)
         
      Case #FormSettings_Button_Chorus
         ButtonFont(#FormSettings_String_Chorus, #Font_Chorus, pd\save\fnt_chorus)
         
      Case #FormSettings_Button_Comments
         ButtonFont(#FormSettings_String_Comments, #Font_Comment, pd\save\fnt_comment)
         
      Case #FormSettings_Spin_Top
         SpinVal(#FormSettings_Spin_Top, pd\save\border_top)
         
      Case #FormSettings_Spin_Left
         SpinVal(#FormSettings_Spin_Left, pd\save\border_left)
         
      Case #FormSettings_Spin_Chorus
         SpinVal(#FormSettings_Spin_Chorus, pd\save\offset_chorus)
         
      Case #FormSettings_Spin_ChordSpace
         SpinVal(#FormSettings_Spin_ChordSpace, pd\save\space_chords)
         
      Case #FormSettings_Spin_LineSpace
         SpinVal(#FormSettings_Spin_LineSpace, pd\save\space_lines)
         
      Case #FormSettings_Spin_LineSpace2
         SpinVal(#FormSettings_Spin_LineSpace2, pd\save\space_lines2)
         
      Case #FormSettings_Spin_LineSpace3
         SpinVal(#FormSettings_Spin_LineSpace3, pd\save\space_lines3)
         
   EndSelect
   
   CanvasDraw()
EndProcedure
Procedure SetRTFText(gadget, text$)
   Protected Buffer$ = Space(StringByteLength(text$,#PB_Ascii)/2 + 2) 
   PokeS(@Buffer$, text$, -1, #PB_Ascii)
   SetGadgetText(gadget, Buffer$)
EndProcedure
;--------------

Procedure FormCombine_Open()
   HideWindow(#FormCombine, 0)
   SetActiveWindow(#FormCombine)
EndProcedure
Procedure FormCombine_Close()
   HideWindow(#FormCombine, 1)   
EndProcedure
Procedure FormCombine_Start()
   ; Kombiniert jeweils zwei Zeilen. 
   ; Es wird davon ausgegangen, daß sich in der Selektion jeweils 
   ; Chords- und Lyrics-Zeile abwechseln
   
   Protected Text$
   Protected Backup$
   Protected a, b
   
   ; Anfang und Ende der Selektion ermitteln
   SendMessage_(GadgetID(#FormMain_Editor), #EM_GETSEL, @a, @b)
   If a = b
      ProcedureReturn 
   EndIf
   
   
   Backup$ = GetClipboardText()  ; Alten Clipboard merken
   
   SendMessage_(GadgetID(#FormMain_Editor), #WM_COPY, 0, 0)  ; Markierung ausschneiden
   Text$ = GetClipboardText()                               ; Ausgeschnittenen Text holen
   
   Text$ = CombineText(Text$)                               ; Kombinieren
   
   SetClipboardText(Text$)                                  ; in die Zwischenablage tun
   SendMessage_(GadgetID(#FormMain_Editor), #WM_PASTE, 0, 0)   ; und wieder einfügen
   
   SetClipboardText(Backup$)                                ; Backup wieder in die Zwischenablage   
EndProcedure

;--------------
Procedure FormTranspose_Open()
   HideWindow(#FormTranspose, 0)
   SetActiveWindow(#FormTranspose)
   SetActiveGadget(#FormTranspose_String_input)
   If GetGadgetText(#FormTranspose_String_input) = "" And pd\firstChord$ > ""
      SetGadgetText(#FormTranspose_String_input, pd\firstChord$ + "  ")
      SendMessage_(GadgetID(#FormTranspose_String_input), #EM_SETSEL, Len(pd\firstChord$) + 1, Len(pd\firstChord$) + 1)
   EndIf
   
EndProcedure
Procedure FormTranspose_Close()
   HideWindow(#FormTranspose, 1)
EndProcedure
Procedure FormTranspose_Button_Start()
   Protected in$, n, mode
   Dim Result$(0)
   
   in$ = GetGadgetText(#FormTranspose_String_input)
   in$ = Trim(in$)
   
   If CreateRegularExpression(0, "(^[A-G][b#]?m?\s+[A-G][b#]?m?)$") 
      If MatchRegularExpression(0, in$)
         mode = 1
      EndIf
      FreeRegularExpression(0)
   EndIf
   
   If CreateRegularExpression(0, "(^bb|b||#|x)[1-8]$|^[1-8](bb|b||#|x)$") 
      If MatchRegularExpression(0, in$)
         mode = 2
      EndIf
      FreeRegularExpression(0)
   EndIf
   
   If mode = 1
      If CreateRegularExpression(0, "[A-G][b#]{0,1}")
         n = ExtractRegularExpression(0, in$, Result$())
         FreeRegularExpression(0)
         If n = 2
            ; SetIntervall(Result$(0), Result$(1), pd\trans)
            pd\transpose = SetTransposeIntervall(Result$(0), Result$(1))
            CanvasDraw()
         Else
            pd\transpose = 0
            CanvasDraw()
         EndIf
         
      EndIf
      pd\trans$ = in$
   EndIf
   
   If mode = 2
      
      pd\transpose = IntervalVal(in$)
      CanvasDraw()
      pd\trans$ = in$
   EndIf
   
EndProcedure


;-------------

Procedure Init()
   ; Programmdaten-Struktur befüllen
   Protected appdata$ = GetProgramDataDirectory()
   CreatePath(appdata$ + "chopro_edit")
   pd\config$ = appdata$ + "chopro_edit/config.json"
   
   
   ; Position und Größe der Fenster
   With pd\save\size_frmMain
      \x = #PB_Ignore
      \y = #PB_Ignore
      \width = #PB_Ignore
      \height = #PB_Ignore
   EndWith
   With pd\save\size_frmSettings
      \x = #PB_Ignore
      \y = #PB_Ignore
      \width = 320
      \height = #PB_Ignore
   EndWith
   With pd\save\size_frmCombine
      \x = #PB_Ignore
      \y = #PB_Ignore
      \width = #PB_Ignore
      \height = #PB_Ignore
   EndWith
   With pd\save\size_frmTranspose
      \x = #PB_Ignore
      \y = #PB_Ignore
      \width = #PB_Ignore
      \height = #PB_Ignore
   EndWith
   
   ; Schriftarten
   With pd\save\fnt_editor
      \name$ = "Courier New"
      \size = 10
      \style = 0
   EndWith
   With pd\save\fnt_title
      \name$ = "Arial"
      \size = 18
      \style = #PB_Font_Bold
      \color = $808000
   EndWith
   With pd\save\fnt_subtitle
      \name$ = "Times New Roman"
      \size = 11
      \style = #PB_Font_Italic
      \color = 0
   EndWith
   With pd\save\fnt_chord
      \name$ = "Arial"
      \size = 10
      \style = #PB_Font_Italic|#PB_Font_Bold
      \color = $ff0000
   EndWith
   With pd\save\fnt_text
      \name$ = "Arial"
      \size = 12
      \style = 0
      \color = 0
   EndWith
   With pd\save\fnt_chorus
      \name$ = "Arial"
      \size = 12
      \style = #PB_Font_Bold
      \color = 0
   EndWith
   With pd\save\fnt_comment
      \name$ = "Arial"
      \size = 10
      \style = #PB_Font_Italic|#PB_Font_Underline
      \color = $808000
   EndWith
   
   ; Ränder/Einrückungen
   With pd\save
      \border_left = 15
      \border_top = 10
      \offset_chorus = 50
      \space_chords = 3
   EndWith
   
   
EndProcedure

Procedure LoadSettings(file$)
   ; Settings Strukturzweig laden
   Protected main, child
   
   If LoadJSON(0, file$)
      InitializeStructure(pd\save, s_savesettings)
      ExtractJSONStructure(JSONValue(0), pd\save, s_savesettings)
      FreeJSON(0)
   EndIf
   
EndProcedure

Procedure SaveSettings(file$)
   ; Settings Strukturzweig speichern
   Protected xml$
   
   If CreateJSON(0)
      InsertJSONStructure(JSONValue(0), pd\save, s_savesettings)
      
      SaveJSON(0, file$, #PB_JSON_PrettyPrint)
      ;SaveJSON(0, file$)
      FreeJSON(0)   
   EndIf
EndProcedure
;----------------------
Procedure.s CombineLine(Chords$, Text$)
   Dim Part.s_chords(1000)
   
   Protected pos1 = 1
   Protected pos2 = 0
   Protected length = 0
   Protected T$, C$, Result$, i, n
   
   If CreateRegularExpression(0, "[^ ]+")
      If ExamineRegularExpression(0, Chords$)
         While NextRegularExpressionMatch(0)
            Part(i+1)\chord$ = "[" + RegularExpressionMatchString(0) + "]" ; nächstes Akkordsymbol
            pos2 = RegularExpressionMatchPosition(0)                       ; an Position 2
            Part(i)\text$ =  Mid(Text$, pos1, pos2 - pos1 )                ; Text vor Pos2
            
            pos1 = pos2             ; die Endposition ist im nächsten durchlauf die Anfangsposition                              
            i + 1                
            If i > 1000
               Debug "Zuviele Parts"
               FreeRegularExpression(0)
               ProcedureReturn "FEHLER"
            EndIf
            
         Wend
         Part(i)\text$ = Mid(Text$, pos1)       ; Restliche Text
         
         n = i                                  ; Parts merken
         
         For i = 0 To n                         ; Alle Parts durchgehen und Teile zusammenbauen
            If Part(i)\text$ = "" And i         
               Result$ + " "                    ; Akkordsymbole ohne Text ein Leerzeichen auseinander
            EndIf
            Result$ + Part(i)\chord$ 
            Result$ + Part(i)\text$
         Next i
         
         ProcedureReturn Result$            
      EndIf
   EndIf
   
   ProcedureReturn ""
   
EndProcedure

Procedure.s CombineText(Text$)
   
   Protected *c.character = @Text$
   Protected Chords$, Lyrics$
   Protected n
   Protected *s = *c
   Protected Result$
   
   While *c\c
      If *c\c = #CR                    ; Zeilenumbruch
         *c\c = 0                      ; Zeilenende markieren
         If n = 0
            Chords$ = PeekS(*s)        ; Chordzeile
         Else
            Lyrics$ = PeekS(*s)        ; Textzeile
            Result$ + CombineLine(Chords$, Lyrics$) + #CRLF$   ; beide Zeilen kombinieren und am Ergebnis anhängen
         EndIf
         *c + SizeOf(character) * 2    ; Zeilenumbruch überpringen
         *s = *c                       ; Anfangsposition neue Zeile
         n ! 1                         ; Zeilennummer immer hin und her wechseln 0 <-> 1
         
      Else
         *c + SizeOf(character)   
      EndIf
   Wend  
   If n = 1
      Lyrics$ = PeekS(*s)              ; Letzte Zeile ohne Umbruch, wenn Lyric-Zeile
      Result$ + CombineLine(Chords$, Lyrics$)      ; Auch kombinieren
   EndIf
   
   ProcedureReturn Result$
EndProcedure

;---------------------

Procedure.l TonVal(a$)
   ; Ein Ton wird gespeichert als Intervall von A aufwärts 
   ; 
   ; es werden die Tonstufen und Halbtonschritten gespeichert 
   ; und in einer Long-Variablen zurückgegeben.
   ; Rechnungen mit Tönen und Intervallen unterscheiden sich nicht.
   
   Protected t.s_ton, v$
   
   t\ton = Asc(a$) - 'A'               ; Stammton
   
   ; Allgemeine Formel: halbtonschritte = stufe * 12 / 7   
   ; Mit dieser Formel ergibt sich eine diatonische Tonleiter, ohne eine Tabelle 
   ; erstellen zu müssen. Allerdings wäre dann E = 0
   ; 
   ; mit den Offsets 6 und 10 verschiebt sich das System so, daß A = 0 ist.
   
   t\hts = (t\ton + 6) * 12 / 7 - 10   ; Halbtonschritte
   
   v$ = Mid(a$, 2)                     ; Vorzeichen im String
   
   ; Korrektur der Halbtonschritte bei Vorzeichen
   If v$ = "bb"      : t\hts - 2       
   ElseIf v$ = "b"   : t\hts - 1
   ElseIf v$ = "#"   : t\hts + 1
   ElseIf v$ = "x"   : t\hts + 2
   EndIf
   
   t\hts = (t\hts + 12) % 12           ; keine Negativen Halbtonschritte
   
   ProcedureReturn PeekL(t)            ; Ton/Intervallwert zurückgeben
   
EndProcedure

Procedure.l TonIntervall(a, b, richtung)
   ; von einem Ton aus ein Intervall hinzufügen.
   ; Intervall kann aufwärts oder abwärts gerichtet sein.
   ;
   
   Protected *a.s_ton = @a    ; Ton 1 bzw. Intervall 1
   Protected *b.s_ton = @b    ; ton 2 bzw. Intervall 2
   
   ; Ergebnis wird wieder in den positiven Bereich verschoben
   *a\ton = (*a\ton + 14 + richtung * *b\ton) % 7     ; zwischen 0 und 6
   *a\hts = (*a\hts + 24 + richtung * *b\hts) % 12    ; zwischen 0 und 11
   
   ProcedureReturn a
EndProcedure

Procedure.s TonStr(a)
   ; Gibt den Ton als Text zurück.
   
   Protected *a.s_ton = @a    
   Protected root$            
   Protected d, *d.s_ton      
   
   root$ = Chr(*a\ton + 'A')           ; Stammton 
   
   d = TonIntervall(a, TonVal(root$), -1) ; Abstand Ton - Stammton, ergibt benötigte Vorzeichen
   *d = @d
   
   ; Am Stammton das benötigte Vorzeichen anhängen
   Select *d\hts
      Case 10  : root$ + "bb"
      Case 11  : root$ + "b"
      Case 1   : root$ + "#"
      Case 2   : root$ + "x"
   EndSelect
   
   ProcedureReturn root$
   
EndProcedure

Procedure.s TransposeChords(Text$, Intervall.l)
   ; Transponiert einen Akkord
   
   Protected  n, i
   Dim result$(0)
   
   If CreateRegularExpression(0, "[A-G](bb|#|x|b){0,1}")
      
      n = ExtractRegularExpression(0, Text$, Result$())
      For i = 0 To n - 1
         result$(i) = TransposeTon(result$(i), Intervall)
      Next i
      
      Text$ = ReplaceRegularExpression(0, Text$, "~")
      
      
      For i = 0 To n - 1
         Text$ = ReplaceString(Text$, "~", result$(i), 0, 1, 1)
      Next i
      
      FreeRegularExpression(0)
   EndIf
   ProcedureReturn Text$
   
EndProcedure   
Procedure IntervalVal(a$)
   ; direkte Eingabe eines Intervalls in Form von Vorzeichen und Stufe:
   ; b3 oder 3b
   Protected vorzeichen$, stufe$, ton$
   
   ; Ausdruck für: (Vorzeichen) Stufe ODER Stufe (Vorzeichen)
   
   If CreateRegularExpression(0, "^(bb|b||#|x)([1-8])$|^([1-8])(bb|b||#|x)$")
      If MatchRegularExpression(0, a$) = 0
         FreeRegularExpression(0)
         Debug "EINGABE ungültig"
         ProcedureReturn 0
      EndIf
      
      If ExamineRegularExpression(0, a$)
         While NextRegularExpressionMatch(0)
            vorzeichen$ + RegularExpressionGroup(0, 1)
            stufe$      + RegularExpressionGroup(0, 2)
            stufe$      + RegularExpressionGroup(0, 3)
            vorzeichen$ + RegularExpressionGroup(0, 4)
         Wend
      EndIf
      
      FreeRegularExpression(0)
   
      ton$ = Chr(Asc(stufe$) - '1' + 'C') + vorzeichen$
      ProcedureReturn SetTransposeIntervall("C", ton$)
   EndIf
   
   ProcedureReturn 0
   
EndProcedure
;---------------


Procedure Draw(List Zeile$(), druck = 0)
   ; Grafikausgabe für Drucker oder Canvas
   
   Protected.i chordInLine               ; Flag: Zeile enthält auch Akkorde enthält
   Protected.d x, y, w, h, w1, h1, w2, h2      ; Schreibposition und Breite/Höhe von Akkord und Text
   Protected.d offset
   Protected.d out_w, out_h              ; Breite/Höhe der Ausgabe
   Protected.i redraw                    ; Flag: Neuzeichnen
   
   Protected text$, code$, pos                ; für Direktiven
   Protected chorus.i
   Protected chord$
   
   pd\firstChord$ = ""
   
   ; Box(0,0, GadgetWidth(#FormMain_Canvas), GadgetHeight(#FormMain_Canvas), $ffffff)       ; Hintergrund weiß
   AddPathBox(0,0, GadgetWidth(#FormMain_Canvas), GadgetHeight(#FormMain_Canvas))
   VectorSourceColor($ffffffff)
   FillPath()
   
   ; DrawingMode(#PB_2DDrawing_Transparent)                                                 ; Transparent
   y = pd\save\border_top                                                                                 ; Rand oben 10
   out_h = y                                                                              ; Höhe der Ausgabe berechnen
   ForEach Zeile$()                                                                       ; alle Zeilen durchgehen
      
      If Left(Zeile$(), 1) = "#"
         ; Kommentarzeile
         Continue
      ElseIf   Asc(Zeile$()) = '{'
         x = pd\save\border_left
         pos = FindString(Zeile$(), "}")
         Text$ = Mid(Zeile$(), 2, pos - 2)
         
         pos = FindString(Text$, ":")
         If pos
            code$ = LCase(Trim(Left(Text$, pos - 1)))
            Text$ = Trim(Mid(Text$, pos + 1))
         Else
            code$ = Text$
            Text$ = ""
         EndIf
         
         Select code$
            Case "title", "t"
               VectorFont(FontID(#Font_Title))                ; Schrift
               VectorSourceColor($ff000000|pd\save\fnt_title\color)                   ; Farbe
            Case "subtitle", "st"
               VectorFont(FontID(#Font_SubTitle))                ; Schrift
               VectorSourceColor($ff000000|pd\save\fnt_subtitle\color)                      ; Farbe
            Case "start_of_chorus", "soc"
               chorus = 1
               offset = pd\save\offset_chorus
               Continue
            Case "end_of_chorus", "eoc"
               chorus = 0
               offset = 0
               Continue
            Case "comment", "c"
               VectorFont(FontID(#Font_Comment))                ; Schrift
               VectorSourceColor($ff000000|pd\save\fnt_comment\color)                     ; Farbe
            Default
         EndSelect
         
         MovePathCursor(x, y)
         DrawVectorText(text$)                   ; Text
         h = VectorTextHeight(text$) + pd\save\space_lines
         w = VectorTextWidth(text$)
         y + h
         x + w
         out_h = MaxD(out_h, y)
         out_w = MaxD(out_w, x)
         
         
         
      Else
         
         
         ; für Normale Zeilen
         NewList part.s_chords()       
         
         If Zeile$() = ""     
            Zeile$() = " "     ; sonst haben wir keine Parts
         EndIf
         
         chordInLine = GetChordParts(Zeile$(), part())         ; Akkorde und Text trennen
                                                               ; Debug "Akkorde: " + chordInLine                       ; anzahl der Akkorde
         
         x = pd\save\border_left + offset                                                ; Rand links
         
         ForEach part()                                        ; alle Akkord-Abschnitte durchgehen
            With part()
               Debug "Orig: " + part()\chord$
               If pd\firstChord$ = ""
                  pd\firstChord$ = part()\chord$
               EndIf
               
               chord$ = TransposeChords(part()\chord$, pd\transpose)
               
               Debug "Trans: " + chord$
               VectorFont(FontID(#Font_Chord))                ; Akkord-Schriftart
               VectorSourceColor($ff000000|pd\save\fnt_chord\color)                   ; und Farbe
               
               MovePathCursor(x, y)
               DrawVectorText(chord$)                   ; Akkord ausgeben
               w1 = VectorTextWidth(chord$)                   ; Akkord breite
               
               If chord$ <> ""
                  w1 + pd\save\space_chords                       ; Zusatzabstand
               EndIf
               
               h1 = 0
               If chordInLine
                  h1 = VectorTextHeight(chord$ + " ")               ; Akkord höhe, nur wenn in der Zeile Akkord sind 
               EndIf
               
               If chorus
                  VectorFont(FontID(#Font_Chorus))
                  VectorSourceColor($ff000000|pd\save\fnt_chorus\color)
               Else
                  VectorFont(FontID(#Font_Text))                 ; Text-Schriftart
                  VectorSourceColor($ff000000|pd\save\fnt_text\color)
               EndIf
               
               MovePathCursor(x, y+h1)
               DrawVectorText(part()\text$)                 ; Text ausgeben
               w2 = VectorTextWidth(\text$)                 ; Textbreite
               h2 = VectorTextHeight(\text$ + " ")          ; Texthöhe
               
               ; Debug w1
               ; Debug w2
               ; Debug h1
                Debug h2
               
               x + MaxD(w1, w2)                                ; neue x-Position für nächsten Akkord-Abschnitt
            EndWith
         Next 
         out_w = MaxD(out_w, x)              ; breiteste Zeile merken
         
         
         y + h1 + h2 + pd\save\space_lines2                        ; Position für nächste Zeile   
         out_h = MaxD(out_h, y)              ; bisherige Höhe merken
      EndIf
   Next
   
   StopVectorDrawing()                          ; Fertig mit zeichnen
   
   If druck = 0
      Debug "Out: " + out_w + " x " + out_h
      
      ; ScrollArea setzen
      SetGadgetAttribute(#FormMain_ScrollArea, #PB_ScrollArea_InnerWidth, out_w+10)        
      SetGadgetAttribute(#FormMain_ScrollArea, #PB_ScrollArea_InnerHeight, out_h + 10)     
      
      ; falls Canvas zu klein war, müssen wir es vergrößern und die Ausgabe wiederholen
      If pd\canvas_w < out_w     ; breiter machen
         ResizeGadget(#FormMain_Canvas, 0, 0, out_w + 10, #PB_Ignore)                     
         pd\canvas_w = out_w
         redraw = 1
      EndIf
      If pd\canvas_h < out_h     ; länger machen
         ResizeGadget(#FormMain_Canvas, 0, 0, #PB_Ignore, out_h + 10)                     
         pd\canvas_h = out_h
         redraw = 1
      EndIf
      ProcedureReturn redraw
   EndIf
EndProcedure
Procedure PrinterDraw()
   Debug "Drucken"
   Protected Text$                     ; ganzer Text
   
   NewList Zeile$()
   
   Text$ = GetGadgetText(#FormMain_Editor)
   
   
   If SplitString(Text$, Zeile$())              ; Text in Zeilen aufsplitten
      
      If PrintRequester()
         If StartPrinting("Lyrics Ausdruck")
            If StartVectorDrawing(PrinterVectorOutput())
               Debug "Breite: " +  VectorOutputWidth()
               Debug "Höhe: " + VectorOutputHeight()
               
               Draw(Zeile$(), 1)
               
            EndIf
            StopPrinting()
         EndIf
      EndIf
   EndIf
   
EndProcedure

Procedure CanvasDraw()
   ; Zeichnet das Canvas neu.
   Protected Text$                     ; ganzer Text
   Protected redraw
   
   NewList Zeile$()
   
   Text$ = GetGadgetText(#FormMain_Editor)
   
   
   If SplitString(Text$, Zeile$())              ; Text in Zeilen aufsplitten
      
      If StartVectorDrawing(CanvasVectorOutput(#FormMain_Canvas))   
         ; Falls das Canvas zu klein war, wird 1 zurückgegeben. Das Canvas wurde vergößert,
         ; aber es muß noch mal gezeichnet werden
         Debug "Breite: " + VectorOutputWidth()
         redraw = Draw(Zeile$())    
      EndIf
      
   EndIf
   
   If redraw
      ; Wiederholtes Zeichen, nur wenn Canvas zu klein war
      If StartVectorDrawing(CanvasVectorOutput(#FormMain_Canvas))
         Draw(Zeile$())
      EndIf
      
   EndIf
   
   
EndProcedure
;-------------------------------
Procedure LoadText(file$)
   ; Lädt Textfile in den Editor
   Protected fmt, Text$
   
   If ReadFile(0, file$)
      fmt = ReadStringFormat(0)
      Text$ = ReadString(0, fmt|#PB_File_IgnoreEOL)
      SetGadgetText(#FormMain_Editor, Text$)   
      CloseFile(0)
   EndIf
EndProcedure
Procedure SaveText(file$)
   ; Speichert Editortext in eine Datei
   Protected fmt, Text$
   
   Text$ = GetGadgetText(#FormMain_Editor)
   
   If CreateFile(0, file$, #PB_UTF8)
      WriteStringFormat(0, #PB_UTF8)
      WriteString(0, Text$)
      CloseFile(0)
   EndIf
EndProcedure


;---------------------

;SetIntervall("C", "E", pd\trans)

Init()
LoadSettings(pd\config$)
FormMain_Open()
;FormSettings_Init()
CreateDynamicDialogs()

Repeat
   WaitWindowEvent()
ForEver

DataSection
   rtf_start:
   IncludeBinary "Verbinden.rtf"   
   rtf_ende:
EndDataSection


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 27
; FirstLine = 27
; Folding = AAAAAAAAAA5
; EnableXP
; Executable = chopro_edit3.exe
; EnablePurifier = 1,1,1,1